# Visualization Library

A lightweight C++ OpenGL middleware for 2D/3D graphics

[Home] [Tutorials] [All Classes] [Grouped Classes]

Public Member Functions | Protected Attributes

# vl::CopyTexSubImage Class Reference

Wrapper class of the OpenGL function glCopyTexSubImage. More...

`#include <CopyTexSubImage.hpp>`

Inheritance diagram for vl::CopyTexSubImage:

List of all members.

## Public Member Functions

virtual const char * | className ()
| Returns the name of the class.
| CopyTexSubImage ()
EReadDrawBuffer | readBuffer () const
| The source buffer used when copying color buffers, ignored when using depth textures.
void | setReadBuffer (EReadDrawBuffer render_buffer)
| The source buffer used when copying color buffers, ignored when using depth textures.
virtual bool | onRenderingStarted (const RenderingAbstract *)
| Reimplement to react to this event.
virtual bool | onRenderingFinished (const RenderingAbstract *)
| Reimplement to react to this event.
virtual bool | onRendererStarted (const RendererAbstract *)
| Reimplement to react to this event.
virtual bool | onRendererFinished (const RendererAbstract *)
| Reimplement to react to this event.
virtual void | copyPixels ()=0
| Copies the pixels from the specified read buffer to the specified texture.

## Protected Attributes

EReadDrawBuffer | mReadBuffer

## Detailed Description

Wrapper class of the OpenGL function glCopyTexSubImage.

Is the base class of CopyTexSubImage1D, CopyTexSubImage2D, CopyTexSubImage3D. Copies a rectangular pixels area from the specified read buffer to the specified portion of the texture. Can be bound to a Rendering as a RenderEventCallback in order to automatically copy the result of a rendering into a texture, see Rendering.

Note:
  This class supports Frame-Buffer-Objects, 3D textures, cubemaps.

See also:
  FBORenderTarget, FBOAbstractAttachment, Rendering, RenderEventCallback, CopyTexSubImage1D, CopyTexSubImage2D, CopyTexSubImage3D

Definition at line 56 of file CopyTexSubImage.hpp.

## Constructor & Destructor Documentation

vl::CopyTexSubImage::CopyTexSubImage | ( | ) | `[inline]`

Definition at line 60 of file CopyTexSubImage.hpp.

References VL_DEBUG_SET_OBJECT_NAME.

## Member Function Documentation

virtual const char* vl::CopyTexSubImage::className | ( | ) | `[inline, virtual]`

Returns the name of the class.

Reimplemented from vl::RenderEventCallback.

Reimplemented in vl::CopyTexSubImage1D, vl::CopyTexSubImage2D, and vl::CopyTexSubImage3D.

Definition at line 59 of file CopyTexSubImage.hpp.

EReadDrawBuffer vl::CopyTexSubImage::readBuffer | ( | ) | const`[inline]`

The source buffer used when copying color buffers, ignored when using depth textures.

Definition at line 66 of file CopyTexSubImage.hpp.

References mReadBuffer.

Referenced by vl::CopyTexSubImage3D::copyPixels(), vl::CopyTexSubImage2D::copyPixels(), and vl::CopyTexSubImage1D::copyPixels().

void vl::CopyTexSubImage::setReadBuffer | ( | EReadDrawBuffer | render_buffer ) | `[inline]`

The source buffer used when copying color buffers, ignored when using depth textures.

Definition at line 69 of file CopyTexSubImage.hpp.

References mReadBuffer.

Referenced by vl::CopyTexSubImage1D::CopyTexSubImage1D(), vl::CopyTexSubImage2D::CopyTexSubImage2D(), and vl::CopyTexSubImage3D::CopyTexSubImage3D().

virtual bool vl::CopyTexSubImage::onRenderingStarted | ( | const RenderingAbstract * | ) | `[inline, virtual]`

Reimplement to react to this event.

Returns:
  `true` if the callback reacted to the given event.

Implements vl::RenderEventCallback.

Definition at line 71 of file CopyTexSubImage.hpp.

References copyPixels().

virtual bool vl::CopyTexSubImage::onRenderingFinished | ( | const RenderingAbstract * | ) | `[inline, virtual]`

Reimplement to react to this event.

Returns:
  `true` if the callback reacted to the given event.

Implements vl::RenderEventCallback.

Definition at line 77 of file CopyTexSubImage.hpp.

References copyPixels().

virtual bool vl::CopyTexSubImage::onRendererStarted | ( | const RendererAbstract * | ) | `[inline, virtual]`

Reimplement to react to this event.

Returns:
  `true` if the callback reacted to the given event.

Implements vl::RenderEventCallback.

Definition at line 83 of file CopyTexSubImage.hpp.

References copyPixels().

virtual bool vl::CopyTexSubImage::onRendererFinished | ( | const RendererAbstract * | ) | `[inline, virtual]`

Reimplement to react to this event.

Returns:
  `true` if the callback reacted to the given event.

Implements vl::RenderEventCallback.

Definition at line 89 of file CopyTexSubImage.hpp.

References copyPixels().

virtual void vl::CopyTexSubImage::copyPixels | ( | ) | `[pure virtual]`

Copies the pixels from the specified read buffer to the specified texture.

Implemented in vl::CopyTexSubImage1D, vl::CopyTexSubImage2D, and vl::CopyTexSubImage3D.

Referenced by onRendererFinished(), onRendererStarted(), onRenderingFinished(), and onRenderingStarted().

## Member Data Documentation

EReadDrawBuffer vl::CopyTexSubImage::mReadBuffer`[protected]`

Definition at line 101 of file CopyTexSubImage.hpp.

Referenced by readBuffer(), and setReadBuffer().

The documentation for this class was generated from the following file:

- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/CopyTexSubImage.hpp

Visualization Library v2011.05.1142 Reference Documentation
Copyright 2005-2011 Michele Bosi. All rights reserved.
Updated on Thu May 26 2011 22:51:37.
Permission is granted to use this page to write and publish articles regarding Visualization Library.